package ${domain}.module.${moduleName}.mpr;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Mapper;
import ${domain}.module.${moduleName}.ent.${table.getCName()};
<#if table.getFind()>
import ${domain}.module.${moduleName}.req.${table.getCName()}FindRequest;
</#if>
<#if table.getSearch()>
import ${domain}.module.${moduleName}.req.${table.getCName()}SearchRequest;
</#if>

import java.util.List;

/**
 * ${table.tableName} - ${table.tableComment}
 *
 * @author ${author?default("")}
 * @since ${.now?string["yyyy-MM-dd"]}
 */
@Mapper
public interface ${table.getCName()}Mapper {

    /**
     * 插入
     *
     * @param request 请求对象
     * @return 返回数量
     */
    long insert(@Param("request") ${table.getCName()} request);

    /**
    * 批量插入
    *
    * @param request 请求对象
    * @return 返回数量
    */
    long insertBatch(@Param("list") List<${table.getCName()}> request);

    /**
     * 逻辑删除
     *
     * @param request 请求对象
     * @return 返回数量
     */
    long delete(@Param("request") ${table.getCName()} request);

    /**
     * 更新
     *
     * @param request 请求对象
     * @return 返回数量
     */
    long update(@Param("request") ${table.getCName()} request);

    /**
     * 普通查询
     *
     * @param request 请求对象
     * @return 返回对象
     */
    List<${table.getCName()}> find(@Param("request") ${table.getCName()} request);
<#if table.getFind()>

    /**
     * 高级查询
     *
     * @param request 请求对象
     * @return 返回对象
     */
    List<${table.getCName()}> find(@Param("request") ${table.getCName()}FindRequest request);
</#if>
<#if table.getSearch()>

    /**
     * 模糊查询
     *
     * @param request 请求对象
     * @return 返回对象
     */
    List<${table.getCName()}> search(@Param("request") ${table.getCName()}SearchRequest request);
</#if>

    /**
     * 获得对象
     *
     * @param request 请求对象
     * @return 返回对象
     */
    ${table.getCName()} getById(@Param("request") ${table.getCName()} request);
}
