-- ----------------------------
-- Table structure for LOGERR - 错误日志
-- Target   : Oracle
-- Author   : wangbing
-- Date:    : 2020-07-11
-- ----------------------------
CREATE TABLE "SYS_LOGERR" (
    "ID" NUMBER(19) NOT NULL,
    "LOG_TYPE" VARCHAR(20) NULL,
    "LOG_TITLE" VARCHAR2(50) NULL,
    "LOG_NOTE" VARCHAR2(500) NULL,
    "LOG_STATE" VARCHAR(20) NULL,
    "ROW_VERSION" NUMBER(19) NOT NULL,
    "IS_DELETED" CHAR(1) NOT NULL,
    "CREATE_BY" NUMBER(19) NOT NULL,
    "CREATE_TIME" DATE NOT NULL,
    "LAST_UPDATE_BY" NUMBER(19) NULL,
    "LAST_UPDATE_TIME" DATE NULL
);

COMMENT ON TABLE "SYS_LOGERR" is '错误日志';
COMMENT ON COLUMN "SYS_LOGERR"."ID" is '主键';
COMMENT ON COLUMN "SYS_LOGERR"."LOG_TYPE" is '日志类型';
COMMENT ON COLUMN "SYS_LOGERR"."LOG_TITLE" is '任务标题';
COMMENT ON COLUMN "SYS_LOGERR"."LOG_NOTE" is '日志描述';
COMMENT ON COLUMN "SYS_LOGERR"."LOG_STATE" is '日志状态';
COMMENT ON COLUMN "SYS_LOGERR"."ROW_VERSION" is '行版本';
COMMENT ON COLUMN "SYS_LOGERR"."IS_DELETED" is '是否已删除';
COMMENT ON COLUMN "SYS_LOGERR"."CREATE_BY" is '创建用户';
COMMENT ON COLUMN "SYS_LOGERR"."CREATE_TIME" is '创建时间';
COMMENT ON COLUMN "SYS_LOGERR"."LAST_UPDATE_BY" is '最后更新用户';
COMMENT ON COLUMN "SYS_LOGERR"."LAST_UPDATE_TIME" is '最后更新时间';
