package ${domain}.frame;

import ${domain}.frame.mail.WMailSender;
import ${domain}.frame.mail.message.WFileMessage;
import ${domain}.frame.mail.message.WHtmlMessage;
import ${domain}.frame.mail.message.WInlineMessage;
import ${domain}.frame.mail.message.WTextMessage;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.transaction.annotation.Transactional;

import java.io.File;

/**
 * UtilTest -  - 测试用例
 *
 * @author wangbing
 * @version 0.0.1
 * @since 2017-01-01
 */
@RunWith(SpringRunner.class)
@SpringBootTest
@Transactional
public class MailTest {

    @Test
    public void testTextMessage() {
        WTextMessage message = new WTextMessage();
        message.setSubject("测试(文本)");
        message.setContent("文本内容");
        message.setTo("1919101440@qq.com");
        WMailSender.send(message);
    }

    @Test
    public void testHtmlMessage() {
        WHtmlMessage message = new WHtmlMessage();
        message.setSubject("测试(HTML)");
        message.setContent("<a href='https://www.baidu.com'>百度一下</a>");
        message.setTo("1919101440@qq.com");
        WMailSender.send(message);
    }

    @Test
    public void testFileMessage() {
        WFileMessage message = new WFileMessage();
        message.setSubject("测试(附件)");
        message.setContent("请参考附件。");
        message.setTo("1919101440@qq.com");
        message.addFile(new File("E:\\A.xlsx"));
        WMailSender.send(message);
    }

    @Test
    public void testInlineMessage() {
        WInlineMessage message = new WInlineMessage();
        message.setSubject("测试(图片)");
        message.setContent("<img src='cid:resId_1'></img>");
        message.setTo("1919101440@qq.com");
        message.addRes("resId_1", new File("E:\\1.jpg"));
        WMailSender.send(message);
    }
}
